#![feature(future_join, box_as_ptr)]

juno_build::juno!("antideps");

fn main() {
    async_std::task::block_on(async {
        let output = simple_antideps(1, 1).await;
        println!("{}", output);
        assert_eq!(output, 5);

        let output = loop_antideps(11).await;
        println!("{}", output);
        assert_eq!(output, 5);

        let output = complex_antideps1(9).await;
        println!("{}", output);
        assert_eq!(output, 20);

        let output = complex_antideps2(44).await;
        println!("{}", output);
        assert_eq!(output, 226);

        let output = very_complex_antideps(3).await;
        println!("{}", output);
        assert_eq!(output, 144);

        let output = read_chains(2).await;
        println!("{}", output);
        assert_eq!(output, 14);

        let output = array_of_structs(2).await;
        println!("{}", output);
        assert_eq!(output, 14);
    });
}

#[test]
fn antideps_test() {
    main();
}
