#![feature(box_as_ptr, let_chains)]

use hercules_rt::HerculesBox;

juno_build::juno!("simple3");

fn main() {
    async_std::task::block_on(async {
        let mut a: Box<[u32]> = Box::new([1, 2, 3, 4, 5, 6, 7, 8]);
        let mut b: Box<[u32]> = Box::new([8, 7, 6, 5, 4, 3, 2, 1]);
        let a = HerculesBox::from_slice_mut(&mut a);
        let b = HerculesBox::from_slice_mut(&mut b);
        let c = simple3(8, a, b).await;
        println!("{}", c);
        assert_eq!(c, 120);
    });
}

#[test]
fn simple3_test() {
    main();
}
